//+------------------------------------------------------------------+
//|                                          Morning_breakout_LJ.mq4 |
//+------------------------------------------------------------------+
#property strict

extern double Lots = 0.1;

extern int MagicNumber = 8673;

extern int start_of_range_at = 7;
extern int end_of_range_at = 8;

extern int start_of_trading = 8;
extern int end_of_trading = 11;

extern bool use_range_limit = true;
extern int range_limit = 500;

extern double coef = 0.3;

extern int max_spread = 15;
extern double controlling_point = 0.0001;

extern bool do_break_even = true;
extern double proportion_of_PT = 0.75;

/////////////////////////////////////////////////////////////////////////////////////

bool inBuyStop = false;
bool inSellStop = false;

bool range_is_OK, trade_buy_allowed_today, trade_sell_allowed_today;

int ticketBuy, ticketSell;

double min_of_range, max_of_range, range;

int number_of_candels;

int OnInit()
   {
   number_of_candels = 60/Period()*(end_of_range_at-start_of_range_at);
   return(INIT_SUCCEEDED);
   }

void OnTick()
{
if(Bars > number_of_candels+1)
{

static int traded_this_day = Day();

if(traded_this_day != Day() && end_of_range_at == Hour())
   {
   traded_this_day = Day();
   min_of_range = Low[iLowest(Symbol(), 0, 1, number_of_candels, 1)];
   max_of_range = High[iHighest(Symbol(), 0, 2, number_of_candels, 1)];
   Print("MIN: ",min_of_range," ... MAX: ",max_of_range);
   
   trade_buy_allowed_today = true;
   trade_sell_allowed_today = true;
   
   range = max_of_range-min_of_range;
   
   if(use_range_limit)
      {
      if(range > (range_limit*Point))
         {
         range_is_OK = false;
         Print("Range is over limit.");
         }
      else
         {
         range_is_OK = true;
         Print("Range is OK.");
         }
      }
   else
      {
      range_is_OK = true;
      Print("Range is OK but has not been checked.");
      }
   }

/////////////////////////////////////////////////////////////////////////////////

bool doBuy = false; 
bool doSell = false;

bool isBuy = false;
bool isSell = false;
bool IsTrade = false;

bool delete_buy = false;
bool delete_sell = false;

bool set_buystop = false;
bool set_sellstop = false;

double enter_of_buy = NormalizeDouble(max_of_range+range*coef, 5);
double enter_of_sell = NormalizeDouble(min_of_range-range*coef, 5);
double SL_of_buy = NormalizeDouble(min_of_range, 5);
double SL_of_sell = NormalizeDouble(max_of_range, 5);


/////////////////////////////////////////////////////////////////////////////////
// CONDITIONS OF ENTRY
if(start_of_trading <= Hour() && end_of_trading >= Hour() && (range_is_OK))
   {
   set_buystop = true;
   }
if(start_of_trading <= Hour() && end_of_trading >= Hour() && (range_is_OK))
   {
   set_sellstop = true;
   }

/////////////////////////////////////////////////////////////////////////////////
// CHECK + POSSIBLE BREAK-EVEN
if(OrderSelect(ticketSell, SELECT_BY_TICKET) && (OrderSymbol() == Symbol()))
   {
   if((OrderType() == OP_SELL) && (OrderMagicNumber() == MagicNumber))
      {
      IsTrade = True;
      isSell = true;
      if(OrderCloseTime() == 0)
         {
         delete_buy = true;
         delete_sell = true;
         }
      if(OrderCloseTime() > 0)
         {
         IsTrade = false;
         isSell = false;
         inSellStop = false;
         ticketSell = 0;
         }
      if(do_break_even)
         {
         if(Bid < OrderOpenPrice()-(proportion_of_PT*(OrderOpenPrice()-OrderTakeProfit())))
            {
            bool BE_sell = OrderModify(ticketSell,OrderOpenPrice(),OrderOpenPrice(), OrderTakeProfit(),0,DodgerBlue);
            if(BE_sell == true)
               { 
   				Print("SELL: ",OrderTicket(),": Order modified successfully on BE level.");
   				}
   			else
   			   {
   				Print("SELL: ",OrderTicket(),": Error in OrderModify during BE. Error code=",GetLastError());
   				}
            }
         }
      }
   }
if(OrderSelect(ticketBuy, SELECT_BY_TICKET) && (OrderSymbol() == Symbol()))
   {
   if((OrderType() == OP_BUY) && (OrderMagicNumber() == MagicNumber))
      {         
      IsTrade = True;
      isBuy = true;
      if(OrderCloseTime() == 0)
         {
         delete_buy = true;
         delete_sell = true;
         }
      if(OrderCloseTime() > 0)
         {
         IsTrade = False;
         isBuy = false;
         inBuyStop = false;
         ticketBuy = 0;
         }
      if(do_break_even)
         {
         if(Ask > OrderOpenPrice()+(proportion_of_PT*(OrderTakeProfit()-OrderOpenPrice())))
            {
            bool BE_buy = OrderModify(ticketBuy,OrderOpenPrice(),OrderOpenPrice(), OrderTakeProfit(),0,DodgerBlue);
            if(BE_buy == true)
               { 
   				Print("BUY: ",OrderTicket(),": Order modified successfully on BE level.");
   				}
   			else
   			   {
   				Print("BUY: ",OrderTicket(),": Error in OrderModify during BE. Error code=",GetLastError());
   				}
            }
         }
      }
   }

/////////////////////////////////////////////////////////////////////////////////
// CONDITIONS
if((!inBuyStop) && (set_buystop) && (trade_buy_allowed_today)) doBuy = true;
if((!inSellStop) && (set_sellstop) && (trade_buy_allowed_today)) doSell = true;

/////////////////////////////////////////////////////////////////////////////////
// DELETE
double spread = MarketInfo(Symbol(),MODE_SPREAD);
if(OrderSelect(ticketSell, SELECT_BY_TICKET) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == MagicNumber) && (OrderType() == OP_SELLSTOP) && (OrderCloseTime() == 0))
   {
   if((delete_sell == true) || ((spread > max_spread) && (MathAbs(OrderOpenPrice()-Bid) < controlling_point)))
      {
      if(spread > max_spread)
         {
         Print("Spread is ",spread,". Delete SellStop: ",ticketSell);
         }

      bool OD_sell = OrderDelete(ticketSell);
      if(OD_sell == true)
         { 
		   Print("Order ",ticketSell," SellStop deleted successfully.");
		   }
		else
		   {
			Print("Error in ",ticketSell," OrderDelete. Error code=",GetLastError());
			}
      inSellStop = false;
      ticketSell = 0;
      }
   }
if(OrderSelect(ticketBuy, SELECT_BY_TICKET) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == MagicNumber) && (OrderType() == OP_BUYSTOP) && (OrderCloseTime() == 0))
   {
   if((delete_buy == true) || ((spread > max_spread) && (MathAbs(OrderOpenPrice()-Ask) < controlling_point)))
      {
      if(spread > max_spread)
         {
         Print("Spread is ",spread,". Delete BuyStop: ",ticketBuy);
         }
      
      bool OD_buy = OrderDelete(ticketBuy);
      if(OD_buy == true)
         { 
		   Print("Order ",ticketBuy," BuyStop deleted successfully.");
		   }
		else
		   {
		   Print("Error in ",ticketBuy," OrderDelete. Error code=",GetLastError());
		   }
      inBuyStop = false;
      ticketBuy = 0;
      }
   }

/////////////////////////////////////////////////////////////////////////////////
// BUY
if(doBuy)
   {
   if(!isBuy)
      {
      ticketBuy = OrderSend(Symbol(), OP_BUYSTOP, Lots, enter_of_buy, 0, 0, 0, IntegerToString(MagicNumber), MagicNumber,  0, DodgerBlue);      
      if(ticketBuy > 0)
         {
         if(OrderSelect(ticketBuy, SELECT_BY_TICKET) && (OrderMagicNumber() == MagicNumber))
            {
            inBuyStop = true;
            trade_buy_allowed_today = false;
				Print("BuyStop order ", OrderTicket()," at price ",OrderOpenPrice());
            }
		   else
		      {
				Print("Error opening BUY order: ", GetLastError());
			   }
         bool OM2_buy = OrderModify(ticketBuy,OrderOpenPrice(),SL_of_buy, OrderOpenPrice()+range,0,DodgerBlue);
         
         if(OM2_buy == true)
            { 
			   Print("Order modified successfully.");
				}
			else
			   {
			   Print("Error in OrderModify. Error code=",GetLastError());
				}
         }
      }
   }
if(doSell)
   {
   if(!isSell)
      {
      ticketSell = OrderSend(Symbol(), OP_SELLSTOP, Lots, enter_of_sell, 0, 0, 0, IntegerToString(MagicNumber), MagicNumber,  0, DeepPink);
      if(ticketSell > 0)
         {
         if(OrderSelect(ticketSell, SELECT_BY_TICKET) && (OrderMagicNumber() == MagicNumber))
            {
            inSellStop = true;
            trade_buy_allowed_today = false;
			   Print("SellStop order ", OrderTicket()," at price ",OrderOpenPrice());
            }
         else
            {
				Print("Error opening SELL order: ", GetLastError());
			   }
         bool OM2_sell = OrderModify(ticketSell,OrderOpenPrice(),SL_of_sell,OrderOpenPrice()-range,0,DeepPink);
         if(OM2_sell == true)
            { 
				Print("Order modified successfully.");
				}
		   else
		      {
				Print("Error in OrderModify. Error code=",GetLastError());
				}
         }
      }
   }
}
}

/////////////////////////////////////////////////////////////////////////////////